aboutsummaryrefslogtreecommitdiffstats
path: root/resources
diff options
context:
space:
mode:
authorMatus Fabian <matfabia@cisco.com>2016-03-08 14:01:32 +0100
committerGerrit Code Review <gerrit@fd.io>2016-03-11 12:23:01 +0000
commit5d5db63262e5c141e5eb435c65154cee214887af (patch)
tree80ec35562acf83c379df7401fb8a6598d2eaf003 /resources
parent05eba892c7d2a778e78a950966fb1a6e0d68aa60 (diff)
Add KW to build QEMU 2.2.1 on node
Change-Id: I58271aff1ef558752f00593bbad5c3317d08288d Signed-off-by: Matus Fabian <matfabia@cisco.com>
Diffstat (limited to 'resources')
-rw-r--r--resources/libraries/bash/qemu_build.sh39
-rw-r--r--resources/libraries/python/QemuUtils.py40
-rw-r--r--resources/libraries/robot/qemu.robot52
3 files changed, 131 insertions, 0 deletions
diff --git a/resources/libraries/bash/qemu_build.sh b/resources/libraries/bash/qemu_build.sh
new file mode 100644
index 0000000000..449cce664f
--- /dev/null
+++ b/resources/libraries/bash/qemu_build.sh
@@ -0,0 +1,39 @@
+#!/bin/bash
+# Copyright (c) 2016 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+echo
+echo Downloading QEMU source
+echo
+sudo rm -rf /tmp/qemu-2.2.1
+cd /tmp
+wget -q http://wiki.qemu-project.org/download/qemu-2.2.1.tar.bz2 || exit
+
+echo
+echo Extracting QEMU
+echo
+tar xjf qemu-2.2.1.tar.bz2 || exit
+rm qemu-2.2.1.tar.bz2
+
+echo
+echo Building QEMU
+echo
+cd qemu-2.2.1
+mkdir build
+cd build
+../configure --target-list=x86_64-softmmu || exit
+make -j`nproc` || exit
+
+echo
+echo QEMU ready
+echo
diff --git a/resources/libraries/python/QemuUtils.py b/resources/libraries/python/QemuUtils.py
new file mode 100644
index 0000000000..c723878499
--- /dev/null
+++ b/resources/libraries/python/QemuUtils.py
@@ -0,0 +1,40 @@
+# Copyright (c) 2016 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+"""QEMU utilities library."""
+
+from robot.api import logger
+from ssh import SSH
+from constants import Constants
+
+
+class QemuUtils(object):
+ """QEMU utilities."""
+
+ @staticmethod
+ def build_qemu(node):
+ """Build QEMU from sources.
+
+ :param node: Node to build QEMU on.
+ :type node: dict
+ """
+ ssh = SSH()
+ ssh.connect(node)
+
+ (ret_code, stdout, stderr) = \
+ ssh.exec_command('sudo -Sn bash {0}/{1}/qemu_build.sh'.format(
+ Constants.REMOTE_FW_DIR, Constants.RESOURCES_LIB_SH), 1000)
+ logger.trace(stdout)
+ if 0 != int(ret_code):
+ logger.debug('QEMU build failed {0}'.format(stderr))
+ raise RuntimeError('QEMU build failed on {0}'.format(node['host']))
diff --git a/resources/libraries/robot/qemu.robot b/resources/libraries/robot/qemu.robot
new file mode 100644
index 0000000000..e26f9aa6bf
--- /dev/null
+++ b/resources/libraries/robot/qemu.robot
@@ -0,0 +1,52 @@
+# Copyright (c) 2016 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+*** Settings ***
+| Library | resources.libraries.python.QemuUtils
+| Library | Collections
+
+*** Keywords ***
+
+| Exist QEMU Build List
+| | [Documentation] | Return TRUE if variable QEMU_BUILD exist, otherwise FALSE
+| | ${ret} | ${tmp}= | Run Keyword And Ignore Error
+| | ... | Variable Should Exist | @{QEMU_BUILD}
+| | Return From Keyword If | "${ret}" == "PASS" | ${TRUE}
+| | Return From Keyword | ${FALSE}
+
+| Is QEMU Ready on Node
+| | [Documentation] | Check if QEMU was built on the node before
+| | [Arguments] | ${node}
+| | ${ret}= | Exist QEMU Build List
+| | Return From Keyword If | ${ret} == ${FALSE} | ${FALSE}
+| | ${ret} | ${tmp}= | Run Keyword And Ignore Error
+| | ... | Should Contain | ${QEMU_BUILD} | ${node['host']}
+| | Return From Keyword If | "${ret}" == "PASS" | ${TRUE}
+| | Return From Keyword | ${FALSE}
+
+| Add Node to QEMU Build List
+| | [Documentation] | Add node to the list of nodes with builded QEMU (global
+| | ... | variable QEMU_BUILD)
+| | [Arguments] | ${node}
+| | ${ret}= | Exist QEMU Build List
+| | Run Keyword If | ${ret} == ${TRUE}
+| | ... | Append To List | ${QEMU_BUILD} | ${node['host']}
+| | ... | ELSE | Set Global Variable | @{QEMU_BUILD} | ${node['host']}
+
+| Build QEMU on Node
+| | [Documentation] | Build QEMU from sources on the Node. Nodes with successful
+| | ... | QEMU build are stored in global variable list QEMU_BUILD
+| | [Arguments] | ${node}
+| | ${ready}= | Is QEMU Ready on Node | ${node}
+| | Return From Keyword If | ${ready} == ${TRUE}
+| | Build QEMU | ${node}
+| | Add Node to QEMU Build List | ${node}